
import os,profile,sys
from stat import *
from tempfile import mkstemp
from sys import argv
from struct import pack,unpack
from collections import deque
from array import array
from bisect import bisect

#import psyco
#psyco.full()

SIZE = 128*1024
BLOCKSIZE = 0x4000
BLOCKS = SIZE / BLOCKSIZE
HEADER = "SMJ\x1a"

def checksum(str):
	sum = 0
	for i in range(128):
		sum += unpack("<I", str[i*128:i*128+4])[0]
	return (sum & 0xffffffff)

def romtrunc(contents, size):
	i = size - 1
	repeat = contents[i]
	if ord(repeat) == 0x00 or ord(repeat) == 0xff:
		i -= 1
		while i > -1 and contents[i] == repeat:
			i -= 1
	return contents[:i + 1]

# read a whole file
def readfile(name):
	fd = open(name, "rb")
	contents = fd.read()
	fd.close()
	return os.stat(name)[ST_SIZE], contents

# write a whole file
def writefile(name, contents):
	fd = open(name, "wb")
	fd.write(contents)
	fd.close()

def writetemp(contents):
	(fd, name) = mkstemp()
	os.write(fd,contents)
	os.close(fd)
	return name

class unapack:

	def __init__(self, src = ""):
		self.src = src

	def getbit(self):
		#print "getbit(src_idx)", self.src_idx
		if self.mask&1:
			self.byte = ord(self.src[self.src_idx])
			self.src_idx += 1
		self.mask = (self.mask>>1) | ((self.mask<<7) & (1<<7))
		#print "getbit", self.byte, self.mask, self.byte&self.mask
		return self.byte&self.mask

	def getbitgamma(self):
		self.gamma <<= 1
		if self.getbit():
			self.gamma += 1
		#print "getbitgamma", self.gamma

	def ap_getgamma(self):
		self.gamma = 1
		self.getbitgamma()
		while self.getbit():
			self.getbitgamma()

	def copyloop(self):
		while self.gamma:
			self.dest += self.dest[-self.recentoff]
			self.gamma -= 1

	def ap_is_lwm(self):
		self.recentoff = ord(self.src[self.src_idx]) + (self.gamma<<8)
		temp_gamma = self.gamma + print_offset
		temp_ord = ord(self.src[self.src_idx])
		self.src_idx += 1
		self.ap_getgamma()
		if self.recentoff >= 32000:
			self.gamma += 1
		if self.recentoff >= 1280:
			self.gamma += 1
		if self.recentoff < 128:
			self.gamma += 2
		#if g_of:
		#	print "%d: dest[-((%d-%d)*256+%d)]*%d : %d" % (len(self.dest), temp_gamma, print_offset, temp_ord, self.gamma, self.src_idx)
		#else:
		#	print "%d: dest[-((%d-%d)*256+%d)]*%d" % (len(self.dest), temp_gamma, print_offset, temp_ord, self.gamma)
		#print "ap_is_lwm", self.recentoff, self.src_idx, self.gamma
		self.copyloop()

	def depack(self):
		global print_offset
		done = 0
		self.dest = self.src[0]
		self.src_idx = 1
		self.mask = 1
		lwm = 0
		while not done:
			if self.getbit():
				if not self.getbit():
					self.ap_getgamma()
					self.gamma -= 2
					#print "lwm", lwm, "gamma", self.gamma
					if lwm:
						print_offset = 2
						#print "branch1"
						self.ap_is_lwm()
					else:
						lwm = 1
						if self.gamma:
							#print "branch2"
							self.gamma -= 1
							print_offset = 3
							#print "ap_is_lwm is called"
							self.ap_is_lwm()
							#print "ap_is_lwm returned"
						else:
							#print "branch3"
							self.ap_getgamma()
							#if g_of:
							#	print "%d: dest[-%d]*%d : %d" % (len(self.dest), self.recentoff, self.gamma, self.src_idx)
							#else:
							#	print "%d: dest[-%d]*%d" % (len(self.dest), self.recentoff, self.gamma)
							self.copyloop()
				elif not self.getbit():
					self.gamma = ord(self.src[self.src_idx])
					self.src_idx += 1
					self.recentoff = self.gamma>>1
					if not self.recentoff:
						done = 1
					else:
						self.dest += self.dest[-self.recentoff]
						self.dest += self.dest[-self.recentoff]
						if self.gamma&1:
							self.dest += self.dest[-self.recentoff]
							#print "%d: dest[-%d]*3 (%d, %d, %d)" % (len(self.dest)-3, self.recentoff, ord(self.dest[-self.recentoff-3]), ord(self.dest[-self.recentoff-2]), ord(self.dest[-self.recentoff-1]))
						#else:
						#	print "%d: dest[-%d]*2 (%d, %d)" % (len(self.dest)-2, self.recentoff, ord(self.dest[-self.recentoff-2]), ord(self.dest[-self.recentoff-1]))
						lwm = 1
				else:
					self.gamma = 0
					self.getbitgamma()
					self.getbitgamma()
					self.getbitgamma()
					self.getbitgamma()
					if self.gamma:
						#print "gamma", self.gamma, len(self.dest)
						#print "%d: dest[-%d] (%d)" % (len(self.dest), self.gamma, ord(self.dest[-self.gamma]))
						self.gamma = ord(self.dest[-self.gamma])
					#else:
					#	print "%d: zero" % len(self.dest)
					self.dest += chr(self.gamma)
					lwm = 0
			else:
				t = self.src[self.src_idx]
				#if g_of:
				#	print "%d: raw: %d : %d" % (len(self.dest), ord(t), self.src_idx)
				#else:
				#	print "%d: raw: %d" % (len(self.dest), ord(t))
				self.dest += t
				self.src_idx += 1
				lwm = 0
		return self.dest


def gbh(filein, fileout):
	size, contents = readfile(filein)
	if contents[0:4] != HEADER:
		print "Not an smj file"
		return 0
	realsize = unpack("<I", contents[8:12])[0]
	flags = realsize>>28
	realsize &= 0x0fffffff
	blocks = realsize / BLOCKSIZE
	if flags:
		blocks -= 3
		if blocks < 0:
			blocks = 0
	offsets = unpack("<%dI" % blocks, contents[16:blocks*4+16])
	if flags:
		if flags & 0x8:
			if blocks:
				end = offsets[0]
			else:
				end = size
			file = unapack(contents[16+blocks*4:end]).depack()
		else:
			print "Unsupported file"
			return 1
	else:
		file = ""
	asize = len(file)
		
	for i in xrange(len(offsets)):
		offset = offsets[i]
		print "%08x" % offset,
		if offset & 0x80000000:
			offset &= 0x0fffffff
			if i == len(offsets) - 1:
				csize = size - offset
			else:
				csize = (offsets[i+1] & 0x0fffffff) - offset
			chunk = unapack(contents[offset:offset+csize]).depack()
		elif offset & 0xF0000000:
			print "Unsupported file"
			return 1
		else:
			if i == len(offsets) - 1:
				csize = size - offset
			else:
				csize = (offsets[i+1] & 0x7fffffff) - offset
			chunk = contents[offset:offset+csize]
		print csize,
		file += chunk
		asize += BLOCKSIZE
		print i, len(chunk), len(file), asize
		file = file.ljust(asize, file[-1])
	writefile(argv[2], file)

if __name__ == "__main__":
	if len(argv) == 3:
		gbh(argv[1], argv[2])
		#profile.run('npc(argv[1], argv[2])')
